function [tdnodes,tdnodesn]=NARVAL_D_RecDijkstra(g,indiplot)
	[lhs,rhs]=argn();
	lhsn=2;
	rhsn=2;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[tdnodes,tdnodesn]=NARVAL_D_RecDijkstra(g,indiplot)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	n=length(g.node_x);
	l=length(g.head);
	tnodes_set=1:n;
	tdnodes=[];
	tdnodesn=[];
	winId=waitbar('topology discovery');
	while (tnodes_set<>[])
		nodes_set=1:n;
		[source,tnodes_set]=NARVAL_F_RandWtRepl(tnodes_set);
		if (source==1)
			nodes_set=[2:n];
		elseif (source==n)
	  		nodes_set=[1:n-1];
		else
			nodes_set=[1:source-1 source+1:n];
		end
		dnodes=[];
		dnodesn=[];
		for i=1:n-1
			[cnode,nodes_set]=NARVAL_F_RandWtRepl(nodes_set);
			[path]=NARVAL_R_Dijkstra_i_j(g,source,cnode);
			int_dnodes=[];
			for j=1:length(path)
				if (length(find(dnodesn==path(j)))==0)
					int_dnodes=[int_dnodes path(j)];
				end   
			end
			totn=dnodes($)+length(int_dnodes);
			dnodes=[dnodes totn];
			dnodesn=[dnodesn int_dnodes];
		end
		tdnodes=[tdnodes;dnodes];
		tdnodesn=[tdnodesn;dnodesn];
		s=1-length(tnodes_set)/n;
		waitbar(min(s,1),winId);
	end
	//winclose(winId);
	scf(indiplot);
	clf(indiplot);
	col=[1 2 3 4 5 6 13 16 23 26 29 32] 
	for i=1:n
		cur=tdnodes(i,:)/n;
		ind=1/n*[1:length(cur)];
		ii=1+modulo(i,12);
		plot2d(ind,cur,style=col(ii),rect=[0 0 1 1]);
	end
	xtitle('Topology discovery from all network nodes','normalized research','normalized topology recovery');
endfunction
