function [g]=NARVAL_G_DeleteNodes(g,nodes)
	[lhs,rhs]=argn();
	lhsn=1;
	rhsn=2;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[go]=NARVAL_G_DeleteNodes(g,nodes)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	//find all edges connected defined nodes
	//sort nodes because of the index shift after removal
	nodes=gsort(nodes);
	lnodes=length(nodes);	
	for i=1:lnodes
		//node nodes(i)
		[e]=NARVAL_G_EdgesOfNode(g,nodes(i));
		[g]=NARVAL_G_DeleteEdges(g,e);
		g.node_x=NARVAL_F_RemovIndex(g.node_x,nodes(i));
		g.node_y=NARVAL_F_RemovIndex(g.node_y,nodes(i));
		g.node_color=NARVAL_F_RemovIndex(g.node_color,nodes(i));
		g.node_border=NARVAL_F_RemovIndex(g.node_border,nodes(i));
		g.node_diam=NARVAL_F_RemovIndex(g.node_diam,nodes(i));
		//need to shift all index superior to nodes(i)
		g.head(find(g.head>nodes(i)))=g.head(find(g.head>nodes(i)))-1;
		g.tail(find(g.tail>nodes(i)))=g.tail(find(g.tail>nodes(i)))-1;
	end
	g.node_number=g.node_number-lnodes;	
	//g.edge_weight=[];
	[g]=NARVAL_G_EdgeLength(g);	
endfunction
