function [g]=NARVAL_G_ForceBasedA(g,damping,timestep,m,lequilibrium,kc,kh,tkel,ind)
	[lhs,rhs]=argn();
	lhsn=1;
	rhsn=9;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[go]=NARVAL_G_ForceBasedA(g)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	ind=2;
	scf(ind);//creation of a graphic window
	clf(ind);
	f=gcf();
	f.figure_name='Force-Directed Layout';
	f.pixmap='on'; //set the pixmap mode
	plot2d(0,0,-1,"011"," ",style=5,rect=[0,0,1000,1000]);//creation of the network boundaries
	xgrid;
	r=20;
	NARVAL_M_Graph2Plot(g.node_x,g.node_y,r,5);//fixed nodes in red (5)
	he=g.head;
	ta=g.tail;
	n=length(g.node_x);
	l=length(g.head);
	vxnodes=zeros(1,n);
	vynodes=zeros(1,n);
	xnodes=g.node_x;
	ynodes=g.node_y;
	for j=1:l
  		xpolys([xnodes([he(j) ta(j)])+r/2]',[ynodes([he(j) ta(j)])-r/2]',1);//display the network links
	end
	show_pixmap();//display
	delta_kinetic_energy=10^9;
	d=10;
	////damping=0.1;// [0..1] the displacement is goind down when the equilibrium is close.
	////timestep=1;//s
	////m=1;//mass of nodes
	////lequilibrium=10;//50
	////kc=100/(L);
	////kh=10*L;//[L..10L]
	qi=1;
	qj=1;
	nx=xnodes;
	ny=ynodes;

	xnodes0=xnodes;//original values
	ynodes0=ynodes;

	sim=1
	siml=1000;
	total_kinetic_energy=10^9;
	////tkel=1;
	while (total_kinetic_energy>tkel)
	//while (siml>sim)
		total_kinetic_energy=0;
		delete(f.children.children(1:$-2));//remove old links before the performance of the current topology
		netforcex=zeros(1,n);
		netforcey=zeros(1,n);
		for i=1:n
			//fr=f.children.children($-1).children(n-i+1);//node i
			v=1:n;
			v=NARVAL_F_Remov(v,i);//all nodes except node i
			for j=v
				[Cx,Cy]=NARVAL_G_CoulombForce(kc,qi,qj,i,j,xnodes,ynodes);
				netforcex(i)=netforcex(i)+Cx;
				netforcey(i)=netforcey(i)+Cy;  
			end
			Neigh=NARVAL_G_NodeNeighbors(i,g);
			for k=Neigh
				[Hx,Hy]=NARVAL_G_HookeForce(kh,i,k,xnodes,ynodes,lequilibrium);
				netforcex(i)=netforcex(i)+Hx;
				netforcey(i)=netforcey(i)+Hy;  
			end 
			//without damping, it moves forever, 0 < damping < 1
			vxnodes(i)=(vxnodes(i)+timestep*sqrt(netforcex(i)*netforcex(i)+netforcey(i)*netforcey(i)))*damping;
			vynodes(i)=(vynodes(i)+timestep*sqrt(netforcex(i)*netforcex(i)+netforcey(i)*netforcey(i)))*damping;
			total_kinetic_energy=total_kinetic_energy+m*(vxnodes(i)*vxnodes(i)+vynodes(i)*vynodes(i));
		end
		//new position of nodes
		for i=1:n
			xnodes(i)= xnodes(i)+timestep*netforcex(i);
			ynodes(i)= ynodes(i)+timestep*netforcey(i);
			f.children.children($-1).children(n-i+1).data(1:2)= [xnodes(i) ynodes(i)];
		end
		for j=1:l
			xpolys([xnodes([he(j) ta(j)])+r/2]',[ynodes([he(j) ta(j)])-r/2]',1);//display the network links
		end
		show_pixmap();//display
		sim=sim+1;
	end
	g.node_x=xnodes;
	g.node_y=ynodes;
	f.pixmap='off'; //set the pixmap mode
endfunction
