function [dist,distv]=NARVAL_G_GraphDegDist(g,plo)
	[lhs,rhs]=argn();
	lhsn=2;
	rhsn=2;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[dist,distv]=NARVAL_G_GraphDegDist(g,plo)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	dist=zeros(1,length(g.node_x));
	distv=[];
	for i=1:length(g.node_x)
		neighi=NARVAL_G_NodeNeighbors(i,g);
		lneighi=length(neighi);
		if (lneighi<>0)
			dist(lneighi)=dist(lneighi)+1;
			distv=[distv lneighi];
		else
			distv=[distv 0];
		end
	end
	scf(plo);
	clf(plo);
	f=gcf();
	f.figure_name="NARVAL_GraphDegDist";
	plot2d3(1:length(dist),dist,rect=[0 0 max(distv) max(dist)]);
	plot2d(1:length(dist),dist,rect=[0 0 max(distv) max(dist)],style=5);
	xtitle('Node Degree Distribution','Degree','Frequency');
endfunction
