function [corner]=NARVAL_IP_Moravec(mat,w)
	[lhs,rhs]=argn();
	lhsn=1;
	rhsn=2;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[corner]=NARVAL_IP_Moravec(mat,w)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	[lig col]=size(mat);
	wi=(w-1)/2;
	//w=1+2*wi;
	corner=zeros(lig,col);
	for x=1+wi+1:lig-wi-1
		for y=1+wi+1:col-wi-1
			A=mat(x-wi:x+wi,y-wi:y+wi);
			B1=mat(x-wi+1:x+wi+1,y-wi:y+wi);
			B2=mat(x-wi+1:x+wi+1,y-wi+1:y+wi+1);
			B3=mat(x-wi:x+wi,y-wi+1:y+wi+1);
			B4=mat(x-wi-1:x+wi-1,y-wi+1:y+wi+1);
			B5=mat(x-wi-1:x+wi-1,y-wi:y+wi);
			B6=mat(x-wi-1:x+wi-1,y-wi-1:y+wi-1);
			B7=mat(x-wi:x+wi,y-wi-1:y+wi-1);
			B8=mat(x-wi+1:x+wi+1,y-wi-1:y+wi-1);
			corner(x,y)=min([sum((A-B1).^2) sum((A-B2).^2) sum((A-B3).^2) sum((A-B4).^2) sum((A-B5).^2) sum((A-B6).^2) sum((A-B7).^2) sum((A-B8).^2)]);    
		end
	end
endfunction
