function [xs,ys,ns]=NARVAL_IP_ObstCornersDet(x,y,direction,n,lc,Tcorel,Tgrad,DT)
	[lhs,rhs]=argn();
	lhsn=3;
	rhsn=8;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[xs,ys,ns]=NARVAL_IP_ObstCornersDet(x,y,direction,n,lc,Tcorel,Tgrad,DT)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	xs=[];
	ys=[];
	ns=[];
	id=1;
	ie=n(1);
	i=1;
	nc=length(n);
	while i<nc
		id=[id ie($)+1];
		ie=[ie ie($)+n(i+1)];
		i=i+1;
	end
	for i=1:nc
		xsc=x(id(i):ie(i));
		ysc=y(id(i):ie(i));
		dsc=direction(id(i):ie(i));
		gradd=abs([dsc(2:$) dsc(1)]-dsc);
		gradd(find(gradd==7))=1;
		gradd(find(gradd==6))=2;
		gradd(find(gradd==5))=3;
		gradg=abs([dsc($) dsc(1:$-1)]-dsc);
		gradg(find(gradg==7))=1;
		gradg(find(gradg==6))=2;
		gradg(find(gradg==5))=3;
		grad=gradd+gradg;
		//lc=2;// correlation 1:+x+ 2:++x++ 3:+++x+++
		h=[-1*ones(1,lc) 0 ones(1,lc)];
		DSC=[dsc($-lc:$) dsc dsc(1:lc)];// add cycle constraints
		corel=[];
		for j=1+lc:n(i)+lc
			cj=[];
			for re=1:lc
				cj=[cj DSC(j+re)-DSC(j-re)];
			end
			//cj=abs(h.*(dsc(j-lc:j+lc)));
			cj=abs(cj);
			cj(find(cj==7))=1;
			cj(find(cj==6))=2;
			cj(find(cj==5))=3;
			corel(j-lc)=mean(cj);//min or max or median
		end
		cgrad=[];
		for j=0:max(grad)
			cgrad=[cgrad length(find(grad==j))];
		end
		ccorel=[];
		for j=0:max(corel)
			ccorel=[ccorel length(find(corel==j))];
		end
		//cgrad=[length(find(grad==0)) length(find(grad==1)) length(find(grad==2)) length(find(grad==3))];
		//ccorel=[length(find(corel==0)) length(find(corel==1)) length(find(corel==2)) length(find(corel==3))];
		//threshold
		//Tcorel=max(corel)-1;
		//Tgrad=max(grad)-1;
		// if maxgrad and maxcorrel -> corner
		candidatecorel=find(corel>=Tcorel);
		candidate=candidatecorel(find(grad(candidatecorel)>=Tgrad));
		//DT=3;//distance min between two corners
		corn=[candidate(1)];
		for j=2:length(candidate)
			if (candidate(j)-corn($)>DT)
				corn=[corn candidate(j)];
			end
		end
		if (xsc(corn($))-xsc(corn(1))+ysc(corn($))-ysc(corn(1))<2*DT)
			corn=corn(1:$-1);
		end
		xs=[xs xsc(corn)];
		ys=[ys ysc(corn)];
		ns=[ns length(corn)];
	end
endfunction

