function [U]=NARVAL_IP_PotentialPath(O,mO)
	[lhs,rhs]=argn();
	lhsn=1;
	rhsn=2;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[U]=NARVAL_IP_PotentialPath(O)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	//O: obstacle 1: free space:0
	winId=waitbar('Potential Performance');
	format('v',6);
	[a,b]=size(O);
	x=a-1;
	y=b-1;
	tot=a*b-length(find(O==1));
	FG=ones(a,b);
	FG(x,y)=0;
	FO=zeros(a,b);
	CFO=NARVAL_IP_DilationW(O,3)-O;
	FO(1:a,1)=1;
	FO(1:a,b)=1;
	FO(1,1:b)=1;
	FO(b,1:b)=1;
	FO(find(CFO<>0))=1;
	F=FO+FG;
	U=mO*ones(a,b);
	U(x,y)=0;
	Qx=x;
	Qy=y;
	while length(Qx)<>0
		Uc=[];
		for k=1:length(Qx)
			Uc=[Uc U(Qx(k),Qy(k))];
		end
		[Pmin,PminI]=min(Uc);
		xm=Qx(PminI);
		ym=Qy(PminI);
		indx=find(Qx==xm);
		ind=indx(find(Qy(indx)==ym));
		[Qx]=NARVAL_F_RemovIndex(Qx,ind);
		[Qy]=NARVAL_F_RemovIndex(Qy,ind);
		//neixm=max([(xm-1) 1]);
		//neixM=min([(xm+1) a]);
		//neiym=max([(ym-1) 1]);
		//neiyM=min([(ym+1) b]);
		for i=-1:1
			for j=-1:1
				if ((xm+i>=1)&(xm+i<=a)&(ym+j>=1)&(ym+j<=b))&(O(xm+i,ym+j)<>1)
					if (U(xm+i,ym+j)>U(xm,ym)+F(xm+i,ym+j))
						U(xm+i,ym+j)=U(xm,ym)+F(xm+i,ym+j);
						Qx=[Qx xm+i];
						Qy=[Qy ym+j];
					end
				end
			end
		end
		waitbar(min(length(find(U<>mO))/tot,1),winId);
	end
	winclose(winId);
endfunction
