function  [swi,rti,network,networks,rp]=NARVAL_I_E2R(swi,rti,rtmax,network,networks,n,bs,rp,t,probroute)
	[lhs,rhs]=argn();
	lhsn=5;
	rhsn=10;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[swi,rti,network,networks,rp]=NARVAL_I_E2R(swi,rti,rtmax,network,networks,n,bs,rp,t,probroute)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	[indp]=NARVAL_I_NEBufferLoc(networks);
	for i=1:length(indp)
		[pile,ps]=NARVAL_I_FirstBPacket(indp(i),networks);
		Ptype=rp(ps,9);//packet type
		if (Ptype==0)//UDP
			rp(ps,[7 8])=[t 1];
			[networks]=NARVAL_I_BufferExchange(indp(i),pile,networks);//the first packet is removed from the current buffer
			[network,rp]=NARVAL_I_AddPackets2Net(ps,network,rp); 
		elseif (Ptype==1)//TCP
			[TCPp,rp]=NARVAL_I_TcpSlidingWind(swi(indp(i)),indp(i),networks,rp,t);//analyse if a TCP packet can be transmitted in respect with the current sliding window
			if (TCPp<>[])
				[network,networks,rp,swi,rti]=NARVAL_I_SendTcpInter(indp(i),TCPp,bs,network,networks,rp,t,swi,rti,rtmax);//packet transfer between the emission and reception networks
			end
		elseif (Ptype==2)//MPTCP
			[MPTCPp,rp]=NARVAL_I_TcpSlidingWind(swi(indp(i)),indp(i),networks,rp,t);
			if (MPTCPp<>[])
				[r]=NARVAL_I_SelectRoute(probroute,(rp(MPTCPp,2)-1)*n+rp(MPTCPp,3));//selection of the path in respect with the route manager
				rp(MPTCPp,10)=r;//update the path taken by the MPTCP packet
				[network,networks,rp,swi,rti]=NARVAL_I_SendTcpInter(indp(i),MPTCPp,bs,network,networks,rp,t,swi,rti,rtmax);//packet transfer between the emission and reception networks
			end
		end
	end
endfunction
