function [lfo,swi,rti,probroute,network,networks,rp,it,at,tt,routep,probch]=NARVAL_I_R2R(g,swi,swmax,rti,rtmax,rt1,rt2,rt3,rt4,rt5,probroute,closs,cack,network,networks,n,rp,t,nd,nf,it,at,tt,routep,probch,probrouteinit)
	[lhs,rhs]=argn();
	lhsn=12;
	rhsn=26;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[swi,rti,network,networks,rp]=NARVAL_I_E2R(swi,rti,rtmax,network,networks,n,bs,rp,t,probroute)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	[indp]=NARVAL_I_NEBufferLoc(network);//location of nodes that store packets
	lfo=[];//initialization of links where a packet is propagated at this time step 
	for i=1:length(indp)
		[p,network]=NARVAL_I_PacketExtract(indp(i),network);//extract the first packet of the node indp(i)	
		if (rp(p,10)<>0)
			path=NARVAL_R_PathERT(evstr('rt'+string(rp(p,10))),rp(p,2),rp(p,3),n);//path performance
		else
			path=[];
		end
		if (path<>[])
			[nextn,ack]=NARVAL_I_NextNode(indp(i),path);//calculation of the node location where the packet should be propagated
			if (ack==0)//the next node is not the destination so the propagation continues
				lfo=[lfo NARVAL_G_Nodes2Path([indp(i) nextn],g)];//we display all links where a packet has been propagated 
				if (rp(p,9)==0)//UDP packet
					[network,rp]=NARVAL_I_UdpPacketIntra(nextn,p,network,rp);
				elseif (rp(p,9)==1)//TCP packet
					[network,rp,swi,rti]=NARVAL_I_TcpPacketIntra(nextn,p,network,rp,t,swi,rti,rtmax);
				elseif (rp(p,9)==2)//MPTCP packet
					[network,rp,swi,rti,probroute]=NARVAL_I_MptcpIntra(nextn,p,network,probroute,closs,cack,n,rp,t,swi,rti,rtmax);  
				end
			else //the next node coincides with the destination: acknowledgement
				if (rp(p,2)==nd)&(rp(p,3)==nf)//data backup for the connection under interest.
					it=[it rp(p,5)];//packet index inside the connection
					at=[at t];//packet arrival time at the destination
					tt=[tt t-rp(p,7)+1];//packet travel time from its emission on the reception network and its arrival at its destination
					probch=[probch [probroute((nd-1)*n+nf,1:5)]'];//route manager state for the connection of interest
					routep=[routep rp(p,10)];//route followed by the packet
				end 
				if (rp(p,9)==0)//UDP packet
					[rp]=NARVAL_I_DeletePackets(rp,p);//the packet is removed from the packet manager 
				elseif (rp(p,9)==1) //TCP packet  
					[rp]=NARVAL_I_PacketAck(rp,p);//the packet is acknowledged
					[rn,sn,ncp,rp,networks]=NARVAL_I_AckPacketsNet(rp,networks,p,swi(rp(p,2)));//acknowledged packets are removed from the emission network
					if (ncp<>0)//it remains packets from the same connection
						swi(sn)=min(swi(sn)+1,swmax);//the sliding window size is incremented
						rti(sn)=max(rti(sn)/2,1);//the retransmission time is halved
					else//update retransmission time and sliding window as the connection is now finished
						rti(sn)=1;
						swi(sn)=1;
					end 
				elseif (rp(p,9)==2) //MPTCP packet
					[rp]=NARVAL_I_PacketAck(rp,p);
					tn=rp(p,3);//source node of the connection
					[rn,sn,ncp,rp,networks]=NARVAL_I_AckPacketsNet(rp,networks,p,swi(rp(p,2)));
					if (ncp<>0)//it remains packets from the same connection
						[probroute]=NARVAL_I_RouteProbChange(probroute,closs,cack,1,rn,sn,tn,n,0);
						//update of the route manager, an acknowledgement (0) on the route rp(p,10)
						swi(sn)=min(swi(sn)+1,swmax);//the sliding window size is incremented
				    		rti(sn)=max(rti(sn)/2,1);//the retransmission time is halved
					else//update retransmission time and sliding window as the connection is now finished
						rti(sn)=1;
						swi(sn)=1;
						[probroute]=NARVAL_I_UpdateProbRoute(probroute,probrouteinit,(sn-1)*n+tn);
						//update probroute with its original value for the defined connection 
			 		end 
	
				end
			end
		else
			[rp]=NARVAL_I_DeletePackets(rp,p);//if the packet provides no path information, it is removed
		end
	end
endfunction
