function [probroute]=NARVAL_I_RouteProbChange(probroute,closs,cack,e,ri,nd,nf,n,m)
	[lhs,rhs]=argn();
	lhsn=1;
	rhsn=9;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[probroute]=NARVAL_I_RouteProbChange(probroute,closs,cack,e,ri,nd,nf,n,m)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	k=(nd-1)*n+nf;//line index of the path between the nodes nd and nf
	P=probroute(k,ri);//initial state of the route manager for the defined connection on the path ri
	l=probroute(k,$);//quantity of alternative paths for the defined connection
	Pmax=0.9;//maximal limit 
	Pmin=0.1;//minimal limit
	if (m==0)//multiplicatif mode
		if (l>1)
			if (P<>1)
				if (e==0)//packet loss on the route ri
					probroute(k,1:l)=probroute(k,1:l)*(1+(1-closs)*P/(1-P));//alternative paths different from ri view their probability increasing 
					probroute(k,ri)=P*closs;//the path ri views its probability increasing
		 		else //acknowledgement on the route ri 
		  			probroute(k,1:l)=probroute(k,1:l)*(1-(cack)*P/(1-P));//alternative paths different from ri view their probability decreasing 
					probroute(k,ri)=P*(1+cack);//the path ri views its probability increasing
   				end
			end
			probroute(k,1:l)=min(max(probroute(k,1:l),Pmin),Pmax);//shape the route manager state for the defined connection
			[minim,kminim]=min(probroute(k,1:l));
			[maxim,kmaxim]=max(probroute(k,1:l));
			if (sum(probroute(k,1:l))<=1)
				probroute(k,kminim)=minim+1-sum(probroute(k,1:l));
			else
				probroute(k,kmaxim)=maxim+1-sum(probroute(k,1:l));		
			end
		end
	end
	if (m==1)//additif mode
		if (l>1)	
			if (P<>1)
				if (e==0)//packet loss on the route ri
					probroute(k,1:l)=probroute(k,1:l)*(1+closs)/(1-P);//alternative paths different from ri view their probability increasing
					probroute(k,ri)=P-closs;//the path ri views its probability increasing
				else //acknowledgement on the route ri
					probroute(k,1:l)=probroute(k,1:l)*(1-(cack)/(1-P));//alternative paths different from ri view their probability decreasing 
					probroute(k,ri)=P+cack;the path ri views its probability increasing
				end
			end
			probroute(k,1:l)=min(max(probroute(k,1:l),Pmin),Pmax);//shape the route manager state for the defined connection
			[minim,kminim]=min(probroute(k,1:l));
			[maxim,kmaxim]=max(probroute(k,1:l));
			if (sum(probroute(k,1:l))<=1)
				probroute(k,kminim)=minim+1-sum(probroute(k,1:l));
			else
				probroute(k,kmaxim)=maxim+1-sum(probroute(k,1:l));		
			end
		end
	end
endfunction
