function [network,rp,swi,rti]=NARVAL_I_TcpPacketIntra(ni,p,network,rp,t,swi,rti,rtmax) 
	[lhs,rhs]=argn();
	lhsn=4;
	rhsn=8;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[network,rp,swi,rti]=NARVAL_I_TcpPacketIntra(ni,p,network,rp,t,swi,rti,rtmax)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	[spile,pile]=NARVAL_I_BufferExtract(ni,network);//extraction of the buffer occupancy of the node ni inside the reception network
	[l c]=size(network);//size of the reception network matrix
	spilen=spile+1;//new buffer size after addition of the new packet
	if (spilen<c)//the addition of a new packet is allowed
		network(ni,[c 1:spilen])=[spilen pile p];//update of the buffer of the node ni
	else//the buffer is full, the packet is rejected from the network
		rp(p,[7 8])=[t+rti(ni) 0];//update of the packet manager
		rti(rp(p,2))=min([rti(rp(p,2))*2 rtmax]);//update the retransmission time vector
		swi(rp(p,2))=max(int(swi(rp(p,2))/2),1);//update the sliding window vector
	end
endfunction
