function NARVAL_M_Mode1N2CAP(r,rf,rs,n,nf,L,ts,vm,Tlim,Tmax,dmax,indiplot)
	[lhs,rhs]=argn();
	lhsn=0;
	rhsn=12;
	if ((rhs<>rhsn))
		message="NARVAL_M_Mode1N2CAP(r,rf,rs,n,nf,L,ts,vm,Tlim,Tmax,dmax,indiplot)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	scf(indiplot);//creation of a graphic window
	clf(indiplot);
	f=gcf();
	f.figure_name='MANET NARVAL_M_Mode1N2CAP' ;
	f.pixmap='on'; //set the pixmap mode
	//creation of the network boundaries
	plot2d(0,0,-1,"011"," ",style=5,rect=[0,0,1000,1000]);
	xgrid;
	[ndep,nfin]=NARVAL_M_Random_i_j_nf(n,nf);//connection extremal nodes
	v=vm*rand(1,n);//velocity
	nodex=L*rand(1,n+nf);//current x-coordinate of all nodes
	nodey=L*rand(1,n+nf);//current y-coordinate of all nodes
	destx=L*rand(1,n+nf);//destination x-coordinate of all nodes(not used for fixed nodes)
	desty=L*rand(1,n+nf);//destination y-coordinate of all nodes(not used for fixed nodes)
	d=sqrt((nodex-destx).^2+(nodey-desty).^2);//initialization of the distance vector
	//display the initial state
	NARVAL_M_Graph2Plot(nodex(nf+1:$),nodey(nf+1:$),r,5);//fixed nodes in red (5)
	NARVAL_M_Graph2Plot(nodex(1:nf),nodey(1:nf),rf,2);//fixed nodes in blue (3)
	f=gcf();//get the figure properties
	i=ndep-nf;//emission node in purple (6)
	f.children.children($-1).children(n-i+1).data(3:4)=[rs rs];//node i
	f.children.children($-1).children(n-i+1).foreground=6;//node i 
	f.children.children($-1).children(n-i+1).background=6;//node i
	show_pixmap();//display
	t=0;
	Tnodes=zeros(1,n);//initialization of breaking time parameters
	he=[];//link head vector
	ta=[];//link tail vector 
	//animation
	while (t<Tlim)
		for i=1:n
			fr=f.children.children($-1).children(n-i+1);//node i 
			[fr.data(1) fr.data(2) destx(i) desty(i) d(i) v(i) Tnodes(i)]=NARVAL_M_NodeRWP(fr.data(1),fr.data(2),destx(i),desty(i),d(i),v(i),Tnodes(i),Tmax,vm,L);//displacement of the node i			
		end
		if (length(he)<>0)//presence of network links
			delete(f.children.children(1:$-3));//remove old links before the performance of the current topology
		end
		[nodx,nody]=NARVAL_M_XYExtraction(f,n,nf);//extraction of the nodes coordinates
		[ta,he]=NARVAL_M_Locality(nodx,nody,dmax);//topology performance
		[dist,pred]=NARVAL_M_Dijkstra(nodx,nody,he,ta,ndep);//calculation of the shortest path between the connection nodes ndep and nfin
		[mx my]=min(dist(1:nf));	
		[path]=NARVAL_R_PredRoute(pred,dist,ndep,my);
		for j=1:length(ta)
			xpolys([nodx([he(j) ta(j)])+r/2]',[nody([he(j) ta(j)])-r/2]',1);//display the network links
		end	
		if (path<>[])//if a path exists between the connection nodes, it is displayed in blue (2) 
    			xpolys([nodx([path])+r/2]',[nody([path])-r/2]',3);
    			f.children.children(1).children.thickness=2;
		end
		show_pixmap();//display the graph
		t=t+1;//time incredent
	end
	f.pixmap='off';
endfunction
