function NARVAL_M_ModeVANETRect(r,rf,rs,n1,n2,n3,n4,L,ts,vm,Tlim,Tmax,dmax,indiplot)
	[lhs,rhs]=argn();
	lhsn=0;
	rhsn=14;
	if ((rhs<>rhsn))
		message="NARVAL_M_ModeVANETRect(r,rf,rs,n1,n2,n3,n4,L,ts,vm,Tlim,Tmax,dmax,indiplot)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	scf(indiplot);//creation of a graphic window
	clf(indiplot);
	f=gcf();
	f.figure_name='VANET NARVAL_M_ModeVANETRect' ;
	f.pixmap='on'; //set the pixmap mode
	//creation of the network boundaries
	plot2d(0,0,-1,"011"," ",style=5,rect=[0,0,1000,1000]);
	xgrid;
	P1x=[100 900 900 100];
	P1y=[100 100 900 900];
	P2x=[130 870 870 130];
	P2y=[130 130 870 870];
	P3x=[160 160 840 840];
	P3y=[160 840 840 160];
	P4x=[190 190 810 810];
	P4y=[190 810 810 190];
	N=[n1 n2 n3 n4];
	n=n1+n2+n3+n4;
	nf=4;
	i1=int(4*rand(1,n1))+1;
	i2=int(4*rand(1,n2))+1;
	i3=int(4*rand(1,n3))+1;
	i4=int(4*rand(1,n4))+1;
	indc=[i1 i2 i3 i4];
	nodex=[145 145 855 855 P1x(i1) P2x(i2) P3x(i3) P4x(i4) ];
	nodey=[145 855 855 145 P1y(i1) P2y(i2) P3y(i3) P4y(i4) ];

	Dind=[NARVAL_M_NextDestination(i1) NARVAL_M_NextDestination(i2) NARVAL_M_NextDestination(i3) NARVAL_M_NextDestination(i4)];
	destx=[P1x(NARVAL_M_NextDestination(i1)) P2x(NARVAL_M_NextDestination(i2)) P3x(NARVAL_M_NextDestination(i3)) P4x(NARVAL_M_NextDestination(i4))];
	desty=[P1y(NARVAL_M_NextDestination(i1)) P2y(NARVAL_M_NextDestination(i2)) P3y(NARVAL_M_NextDestination(i3)) P4y(NARVAL_M_NextDestination(i4))];
	xfpolys([[P1x P1x(1)]+[-15 15 15 -15 -15]]',[[P1y P1y(1)]+[-15 -15 15 15 -15]]',31);//12
	f.children.children(1).children.thickness=1;
	xfpolys([[P1x P1x(1)]+[15 -15 -15 15 15]]',[[P1y P1y(1)]+[15 15 -15 -15 15]]',31);//12
	f.children.children(1).children.thickness=1;
	xfpolys([[P2x P2x(1)]+[15 -15 -15 15 15]]',[[P2y P2y(1)]+[15 15 -15 -15 15]]',30);//16
	f.children.children(1).children.thickness=1;
	xfpolys([[P3x P3x(1)]+[15 15 -15 -15 15]]',[[P3y P3y(1)]+[15 -15 -15 15 15]]',30);//16
	f.children.children(1).children.thickness=1;
	xfpolys([[P4x P4x(1)]+[15 15 -15 -15 15]]',[[P4y P4y(1)]+[15 -15 -15 15 15]]',8);//8
	f.children.children(1).children.thickness=1;
	initdestx=destx;
	initdesty=desty;
	//simulation scenario
	[ndep,nfin]=NARVAL_M_Random_i_j_nf(n,nf);//connection extremal nodes
	v=vm*rand(1,n);//velocity
	d=sqrt((nodex(1:n)-destx).^2+(nodey(1:n)-desty).^2);//initialization of the distance vector
	//display the initial state
	NARVAL_M_Graph2Plot(nodex(nf+1:$),nodey(nf+1:$),r,1);//fixed nodes in black (1)red (5)
	NARVAL_M_Graph2Plot(nodex(1:nf),nodey(1:nf),rf,5);//fixed nodes in green (3)
	f=gcf();//get the figure properties
	i=ndep-nf;//emission node in purple (6)
	f.children.children(2).children(n-i+1).data(3:4)=[rs rs];//node i
	f.children.children(2).children(n-i+1).foreground=3;//node i 
	f.children.children(2).children(n-i+1).background=3;//node i
	show_pixmap();//display
	t=0;
	Tnodes=zeros(1,n);//initialization of breaking time parameters
	he=[];//link head vector
	ta=[];//link tail vector 
	col=[3 5 2 6];
	cb=1;
	//animation
	while (t<Tlim)
		for i=1:n
			fr=f.children.children($-6).children(n-i+1);//node i
			if (i<=n1)
				Px=P1x;
				Py=P1y;
			elseif (i<=n1+n2)
				Px=P2x;
				Py=P2y;
			elseif (i<=n1+n2+n3)
				Px=P3x;
				Py=P3y;
			else
				Px=P4x;
				Py=P4y;
			end
			[fr.data(1) fr.data(2) destx(i) desty(i) indc(i) d(i) v(i) Tnodes(i)]=NARVAL_M_NodeRWPoint(fr.data(1),fr.data(2),destx(i),desty(i),indc(i),Px,Py,d(i),v(i),Tnodes(i),Tmax,vm,L);			
		end
		if (length(he)<>0)//presence of network links
			delete(f.children.children(1:$-8));//remove old links before the performance of the current topology
		end
		[nodx,nody]=NARVAL_M_XYExtractionB(f,n,nf);//extraction of the nodes coordinates
		[ta,he]=NARVAL_M_Locality(nodx,nody,dmax);//topology performance
		[dist,pred]=NARVAL_M_Dijkstra(nodx,nody,he,ta,ndep);//calculation of the shortest path between the connection nodes ndep and nfin
		[mx my]=min(dist(1:nf));	
		[path]=NARVAL_R_PredRoute(pred,dist,ndep,my);
		for j=1:length(ta)
			xpolys([nodx([he(j) ta(j)])+r/2]',[nody([he(j) ta(j)])-r/2]',1);//display the network links
		end	
		if (path<>[])//if a path exists between the connection nodes, it is displayed in blue (2) 
    			xpolys([nodx([path])+r/2]',[nody([path])-r/2]',3);
    			f.children.children(1).children.thickness=2;
		end
		show_pixmap();//display the graph
		t=t+1;//time incredent
	end
	f.pixmap='off';
endfunction
