function [nx,ny,dx,dy,d,v,tn]=NARVAL_M_NodeRWP(nx,ny,dx,dy,d,v,tn,tnmax,vm,L)
	[lhs,rhs]=argn();
	lhsn=7;
	rhsn=10;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[nx,ny,dx,dy,d,v,tn]=NARVAL_M_NodeRWP(nx,ny,dx,dy,d,v,tn,tnmax,vm,L)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	if (tn == 0)//allowed displacement
		if (d-v>0)//allowed movement along the vector current-position --> PoI at the speed v
			x=v*(dx-nx)/d;//delta x 
			y=v*(dy-ny)/d;//deta y
			nx=nx+x;
			ny=ny+y;
			d=d-v;//distance update	
		else//the node reaches its PoI	
			x= dx-nx;
			y= dy-ny;		
			nx=dx;
			ny=dy;
			dx=L*rand(1,1);//PoI update:selection of a new destination
			dy=L*rand(1,1);
			d=sqrt((dx-nx)^2+(dy-ny)^2);//distance update
			v=vm*rand();//velocity update
			tn=int(tnmax*rand()+1);//breaktime update
		end
	else//breaktime
		tn=tn-1;
	end
endfunction
