function [nx,ny,dx,dy,id,d,v,tn]=NARVAL_M_NodeRWPoint(nx,ny,dx,dy,id,Px,Py,d,v,tn,tnmax,vm,L)
	[lhs,rhs]=argn();
	lhsn=8;
	rhsn=13;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[nx,ny,dx,dy,id,d,v,tn]=NARVAL_M_NodeRWPoint(nx,ny,dx,dy,id,Px,Py,d,v,tn,tnmax,vm,L)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	if (tn == 0)//allowed displacement
		if (d-v>0)//allowed movement along the vector current-position --> PoI at the speed v
			x=v*(dx-nx)/d;//delta x 
			y=v*(dy-ny)/d;//deta y
			nx=nx+x;
			ny=ny+y;
			d=d-v;//distance update	
		else//the node reaches its PoI	
			x= dx-nx;
			y= dy-ny;		
			nx=dx;
			ny=dy;
			id=id+1;
			if (id==5);//rectangle 1->2->3->4->1...
				id=1;
			end
			dx=Px(id);
			dy=Py(id);
			d=sqrt((dx-nx)^2+(dy-ny)^2);//distance update
			v=vm*rand();//velocity update
			tn=int(tnmax*rand()+1);//breaktime update
		end
	else//breaktime
		tn=tn-1;
	end
endfunction
