function [g,p2plist,routetab,T]=NARVAL_P_OL2UL_NodeSel(g,np2p)
	[lhs,rhs]=argn();
	lhsn=4;
	rhsn=2;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[g,p2plist,routetab,T]=NARVAL_P_OL2UL_NodeSel(g,np2p,ind)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	//underlay: graph where overlay nodes are displayed in red
	//p2plist: list of overlay nodes in respect with node numbering in the underlay topology 
	//routetab: underlay paths for each direct overlay link between overlay nodes ([path length|underlay path]);extreme nodes belong to the overlay
	//T is the overlay topology according to a numbering based on information slicing
	//n: underlay size
	p2plist=[];
	n=length(g.node_x);
	nl=length(g.head);
	nodb=3*ones(1,n);
	nodc=ones(1,n);
	EC=ones(1,nl);
	EB=ones(1,nl);
	ind=1:n;
	for i=1:np2p
		nc=ind(NARVAL_F_Random(length(ind)));
		p2plist=[p2plist nc];
		ind=NARVAL_F_Remov(ind,nc);
	end
	nodb(p2plist)=6;
	nodc(p2plist)=5;
	g.node_border=nodb;
	g.node_color=nodc;
	//[gd,gp] = graph_diameter(g);
	routetab=zeros(np2p,n+1);
	T=matrix(1:np2p,d,ln);   
	lig=1;
	for s=1:L
		for l1=1:d
			for l2=1:d
				[path]=NARVAL_R_Dijkstra_i_j(g,p2plist(T(l1,s)),p2plist(T(l2,s+1)));
				lp=length(path);
				routetab(lig,1)=lp;
				if (lp<>0)
					routetab(lig,2:1+lp)=path;
					p=NARVAL_G_Nodes2Path(path,g);
					EC(p)=5;
					EB(p)=2;
				end
				lig=lig+1;
			end
		end
	end
	g.edge_color=EC;
	g.edge_width=EB;
	routetab=routetab(:,1:max(routetab(:,1))+1);
endfunction
