function [OLRT,OLpres]=NARVAL_P_SliceOLProp(np2p,d,T)
	[lhs,rhs]=argn();
	lhsn=2;
	rhsn=3;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[OLRT,OLpres]=NARVAL_P_SliceOLProp(np2p,d,T)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	//OLRT: routing table providing the path followed by each slice along the overlay network
	//collection of all slice crossing each overlay node (for global routing information retrieved by overlay nodes)
	OLRT=[];
	OLpres=zeros(np2p,np2p*d);
	count=np2p*d;
	for k=L:-1:1
		for j=(k+1)*d:-1:k*d+1
			OLi=j*ones(d,1);
			for i=k:-1:1
				v=NARVAL_F_RandomNiNj(T(1,i),T(d,i));
				OLi=[v OLi];
			end
			for z=d:-1:1
				OLpres(OLi(z,:),count)=1;
				count=count-1;
			end
			if (k==L)
				OLRT=[OLRT; OLi]; 
			else
				OLRT=[OLRT; OLi zeros(d,L-k)];
			end
		end
	end
endfunction
