function [node_pres,node_pres_stage]=NARVAL_P_UnderlayInter(routetab,n,ln,d,w1,w2)
	[lhs,rhs]=argn();
	lhsn=2;
	rhsn=6;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[node_pres,node_pres_stage]=NARVAL_P_UnderlayInter(routetab,n,ln,d,w1,w2)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	//node_pres: cummulative occurence of each underlay node in the overlay graph
	//node_pres_stage: occurence of each underlay node in the overlay graph between any 2 successive overlay stages 
	node_pres=zeros(1,n);
	for i=1:n
		node_pres(i)=length(find(routetab(:,2:$)==i));
	end
	scf(w1);
	clf(w1);
	plot2d3(1:n,node_pres,rect=[1 0 n max(node_pres)]);
	xtitle('cumulative quantity of overlapping nodes between any consecutive OL stages'); 
	col=[1 2 3 5 6 7 9 10 11];
	//col=[-1:-1:-9];
	lcol=length(col);
	scf(w2);
	clf(w2);
	node_pres_stage=zeros(L,n);
	st=d*d;
	cb=1;
	legx=[];
	legcol=[];
	L=ln-1;
	for i=1:L
		for j=1:n
			node_pres_stage(i,j)=node_pres_stage(i,j) + length(find(routetab(1+st*(i-1):i*st,2:$)==j));
		end
		plot2d(1:n,node_pres_stage(i,:),style=col(modulo(cb,lcol)+1),rect=[1 0 n max(node_pres)]);
		plot2d(1:n,node_pres_stage(i,:),style=-2,rect=[1 0 n max(node_pres)]);
		nexti=i+1;
		legx=[legx 'Stages: '+string(i)+' to '+string(nexti)];
		legcol=[legcol col(modulo(cb,lcol)+1)];
		cb=cb+1;
	end
	legends(legx,legcol,opt="ur");
	xtitle('quantity of overlapping nodes between two consecutive OL stages');
endfunction
