function [dataWCDSA]=NARVAL_R_AggregationWCDS(g,gnu,nucleus,sink)
	[lhs,rhs]=argn();
	lhsn=1;
	rhsn=4;
	if ((lhs<>lhsn))
		message="[dataWCDSA]=NARVAL_R_AggregationWCDS(g,gnu,nucleus,sink)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	isink=find(nucleus==sink);
	//isink=sink;
	[vWCDSnucleusDFSWeight,predWCDSnucleusDFSWeight]=NARVAL_R_DFSWWD(gnu,isink);
	distWCDSnucleusDFSWeight=ones(1,length(nucleus));
	n=g.node_number;
	dataWCDSA=zeros(n,n+1);
	[dataWCDSAnucleus]=NARVAL_R_AggregationTree(predWCDSnucleusDFSWeight,ones(1,length(nucleus)),isink);
	dataWCDSA=zeros(n,n+1);
	predWCDSelectron=zeros(1,n);
	[d_wcds,dv_wcds]=NARVAL_G_GraphDegDistWD(g);
	electron=1:g.node_number;
	for i=1:length(nucleus)
		electron=NARVAL_F_Remov(electron,nucleus(i));
	end
	for k=electron
		//determination of all nucleus connected to the current electron
		nk=NARVAL_G_NodeNeighbors(k,g);
		nknucleus=[];
		for h=1:length(nk)
			if find(nucleus==nk(h))
				nknucleus=[nknucleus nk(h)];
			end 
		end
		[aa bb]=max(dv_wcds(nknucleus));
		predWCDSelectron(k)=nknucleus(bb);
	end	
	for t=1:length(nucleus)
		//one nucleus + all electron
		infoN=[nucleus(t) find(predWCDSelectron==nucleus(t))];
		linfoN=length(infoN);
		[dnucleus]=nucleus(dataWCDSAnucleus(t,1:dataWCDSAnucleus(t,$)));
		infoloc=[];
		for u=1:length(dnucleus)
			infoloc=[infoloc dnucleus(u) find(predWCDSelectron==dnucleus(u))];
		end
		linfoloc=length(infoloc);
		dataWCDSA(nucleus(t),1:linfoloc)=infoloc;
		dataWCDSA(nucleus(t),$)=linfoloc; 
	end
	vnucleus=nucleus;
	[vnucleus]=NARVAL_F_Remov(vnucleus,sink);
	for b=1:length(vnucleus)
		indi=find(nucleus==vnucleus(b));
		nextnucleus=nucleus(predWCDSnucleusDFSWeight(indi));//connection between vnucleus(b) and nextnucleus
		//[vnucleus(b);nextnucleus] OK  
		PNN=NARVAL_R_Dijkstra_i_j(g,vnucleus(b),nextnucleus);//physical path
		if length(PNN==3) & find(electron==PNN(2))
			//PNN
			//electron in consideration
			infoelectron=[PNN(2) dataWCDSA(vnucleus(b),1:dataWCDSA(vnucleus(b),$))];
			linfoelectron=length(infoelectron);
			dataWCDSA(PNN(2),1:linfoelectron)=infoelectron;
			dataWCDSA(PNN(2),$)=linfoelectron;
		end
	end
endfunction
