function [g,V,pred]=NARVAL_R_BFS(g,x,dw,ind)
	[lhs,rhs]=argn();
	lhsn=3;
	rhsn=4;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[g,V,pred]=NARVAL_R_BFS(g,x,dw,ind)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	n=length(g.node_x);
	l=length(g.head);
	EB=2*ones(1,l);
	NB=5*ones(1,n);
	NC=ones(1,n);
	pred=zeros(1,n);
	V=[];//visited
	C=[];//candidates
	D=zeros(1,n);
	[V,C,pred]=NARVAL_R_SearchStart(x,g,V,C,pred);
	D(x)=0;
	while (length(C)<>0)
		[V,C,pred]=NARVAL_R_SearchStart(C(1),g,V,C,pred);
		D(V($))=D(pred(V($)))+1;
	end
	edgecolor=ones(1,l);
	edgewidth=2*ones(1,l);
	tree=[];
	for j=1:n
		ns=NARVAL_G_Nodes2Path([j pred(j)],g);		
		EB(ns)=(D(j)*dw/max(D))+1;
		tree=[tree ns];
	end
	edgecolor(tree)=2;
	edgewidth(tree)=2;
	NB(x)=20;
	NC(x)=5;
	g.node_border=NB;
	g.node_color=NC;
	g.edge_color=edgecolor;
	g.edge_width=EB;
	scf(ind);
	clf(ind);
	f=gcf();
	[f]=NARVAL_G_ShowGraph(g,ind);
	f.figure_name="NARVAL_R_BFS";
endfunction
