function [dist,pred]=NARVAL_R_BellmanFord(g,i)
	[lhs,rhs]=argn();
	lhsn=2;
	rhsn=2;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[dist,pred]=NARVAL_R_BellmanFord(g,i)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	dist=100000000*ones(1,length(g.node_x));
	dist(i)=0;
	pred=zeros(1,length(g.node_x));
	for k=1:length(g.node_x)
		for j=1:length(g.head)
			u=g.head(j);
			v=g.tail(j);
			//i-->j
			if (dist(v)>dist(u)+g.edge_length(j))
				dist(v)=dist(u)+g.edge_length(j);
				pred(v)=u;
			end
			u=g.tail(j);
			v=g.head(j);
			//j-->i
			if (dist(v)>dist(u)+g.edge_length(j))
				dist(v)=dist(u)+g.edge_length(j);
				pred(v)=u;
			end    
		end
	end
	for j=1:length(g.head)
		u=g.head(j);
		v=g.tail(j);
		if (dist(v)>dist(u)+g.edge_length(j))
			error('Graph contains a negative-weight cycle');
		end
	end
endfunction
