function [Path,Next]=NARVAL_R_FloydWarshall(g)
	[lhs,rhs]=argn();
	lhsn=2;
	rhsn=1;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[Path,Next]=NARVAL_R_FloydWarshall(g)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	n=length(g.node_x);
	l=length(g.tail);
	W=zeros(n,n);  
	Next=zeros(n,n);
	Path=zeros(n,n);
	for p=1:l 
  		Path(g.head(p),g.tail(p))=g.edge_length(p);
		Next(g.head(p),g.tail(p))=g.tail(p);
		Path(g.tail(p),g.head(p))=Path(g.head(p),g.tail(p));
		Next(g.tail(p),g.head(p))=g.head(p);
	end
	Path(find(Path==0))=10^9;
	for k=1:n
		for i=1:n
			for j=1:n
				if (Path(i,j)>Path(i,k)+Path(k,j))
					Path(i,j)=Path(i,k)+Path(k,j);
					Next(i,j)=k;
				end
			end
		end
	end
endfunction
