function [ge,diam,nlevel]=NARVAL_T_HierWaxmanConD(alph,bet,n,L,N,stage,diamb,diffdiam,colov)
	[lhs,rhs]=argn();
	lhsn=3;
	rhsn=9;
	if ((lhs<>lhsn) | (rhs<>rhsn))
		message="[ge,diam,nlevel]=NARVAL_T_HierWaxmanConD(alph,bet,n,L,N,stage,diamb,diffdiam,colov)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end
	ld=stage+2;
	mu=(ld+1)/2;
	x=1:ld;
	dist=x;//dist=exp(-(x - mu).^2);
	dist=dist/(sum(dist));
	nlevel=int(dist*n);
	nlevel($)=nlevel($)+(n-sum(nlevel));
	conn=0;
	while (conn==0)
		[g,conn]=NARVAL_T_WaxmanConnex2(alph,bet,nlevel(1),L);
	end
	nlevel($)=nlevel($)+nlevel(1)-length(g.node_x);
	nlevel(1)=length(g.node_x);
	diam=diamb*ones(1,length(g.node_x));
	colo=colov(1)*ones(1,length(g.node_x));
	le=length(g.tail);
	edg_colo=colov(1)*ones(1,le);
	ge=g;
	v=[length(ge.node_x)];
	nn_deb=1;
	nn_fin=length(ge.node_x);
	count=0;
	while (count<= nlevel(2))
		rl=ceil(N*rand());
		if (count+rl<nlevel(2))
			i=nn_deb+int((nn_fin-nn_deb+1)*rand());
			[ge]=NARVAL_G_WCirclePlace(alph,bet,rl,L/10,ge,i);
		end
  		count=count+rl;
	end
	nlevelnew=length(ge.node_x)-sum(nlevel(1:1));
	nlevel($)=nlevel($)+nlevel(2)-nlevelnew;
	nlevel(2)=nlevelnew;
	v=[v length(ge.node_x)];
	l=length(nn_fin+1:length(ge.node_x));
	lint=length(ge.tail);
	edg_colo=[edg_colo colov(2)*ones(1,lint-le)];
	le=lint;
	diamb=diamb-diffdiam;
	diam=[diam diamb*ones(1,l)];
	colo=[colo (colov(2))*ones(1,l)];
	for j=1:stage-1
		nn_deb=nn_fin+1;
		nn_fin=length(ge.node_x);
		count=0;
		while (count<=nlevel(j+2))
			rl=ceil(j*N*rand());
			if (count+rl<nlevel(j+2))
				i=nn_deb+int((nn_fin-nn_deb+1)*rand());
				[ge]=NARVAL_G_WCirclePlace(alph,bet,rl,L/(5^j),ge,i);
			end
			count=count+rl;
		end
		nlevelnew=length(ge.node_x)-sum(nlevel(1:j+1));
		nlevel($)=nlevel($)+nlevel(j+2)-nlevelnew;
		nlevel(j+2)=nlevelnew;
		v=[v length(ge.node_x)];
		lint=length(ge.tail);
		edg_colo=[edg_colo colov(j+2)*ones(1,lint-le)];
		le=lint;
		l=length(nn_fin+1:length(ge.node_x));
		diamb=diamb-diffdiam;
		diam=[diam diamb*ones(1,l)];
		colo=[colo colov(j+2)*ones(1,l)];	
	end
	nn_deb=nn_fin+1;
	nn_fin=length(ge.node_x);
	count=0;
	while (count<=nlevel($))
		rl=ceil(j*N*rand());
		if (count+rl<nlevel($))
			i=nn_deb+int((nn_fin-nn_deb+1)*rand());
			[ge]=NARVAL_G_CirclePlace(rl,L/(5^stage),ge,i);
		end
		count=count+rl;
	end
	remain=n-length(ge.node_x);
	i=nn_deb+int(nn_fin-nn_deb+1)*rand();
	[ge]=NARVAL_G_CirclePlace(remain,L/(5^stage),ge,i);
	v=[v length(ge.node_x)];
	l=length(nn_fin+1:length(ge.node_x));
	lint=length(ge.tail);
	edg_colo=[edg_colo colov(stage+2)*ones(1,lint-le)];
	le=lint;
	diamb=diamb-diffdiam;
	diam=[diam diamb*ones(1,l)];
	colo=[colo colov(stage+2)*ones(1,l)];
	ge.head=int(ge.head);
	ge.node_diam=diam;
	ge.node_color=colo;
	ge.edge_color=edg_colo;
	[ge]=NARVAL_G_EdgeLength(ge);
endfunction

