function [g,nucleus,electron]=NARVAL_W_WCDS(g)
	[lhs,rhs]=argn();
	lhsn=3;
	rhsn=1;
	if ((lhs<>lhsn))
		message="[go]=NARVAL_W_CDS(g)";
		error(msprintf("Correct Syntax: %s: Expected %d input and %d output arguments",message,rhsn,lhsn));
	end	
	[d,dv]=NARVAL_G_GraphDegDistWD(g);
	[dM,dMi]=max(dv);
	Col=[2 5 1];
	n=length(g.node_x);
	l=length(g.head);
	gnc=Col(1)*ones(1,n);
	gnb=5*ones(1,n);
	//Weakly Connected Dominating Set
	//T: selection of the seed=single black piece
	T=[];
	//each vertex can be : white=0, gray=1 or black=2.
	//candidate
	CN=[];
	//initialization: all nodes are white
	//When a white or gray vertex is colored in black, all white neighboring vertices become gray.
	//when a vertex is dyed black, it is placed in T along with all of its newly gray neihbors.
	//selection of an arbitrary vertex
	//a candidate vertex is chosen to dye black
	T=dMi;//the sink is selected as the most connected nodes
	gnc(T)=Col(3);
	gnb(T)=7;
	g.node_color=gnc;
	g.node_border=gnb;
	N=NARVAL_G_NodeNeighbors(T,g);
	gnc(N)=Col(2);
	gnb(N)=3;
	T=[T N];
	while(length(find(gnc==Col(1)))<>0)
		//candidates consist of the gray vertice of T and the white vertice adjacent to those gray vertice
		CandGrey=T(find(gnc(T)==Col(2)));
		CandWhite=[];
		for i=1:length(CandGrey)
			NW=NARVAL_G_NodeNeighbors(CandGrey(i),g);  
			CandWhite=[ CandWhite NW(find(gnc(NW)==Col(1)))];
		end
		Cand=unique([CandGrey CandWhite]);
		CandWN=[];
		//for each candidate, we count the number of white vertices that are in the direct neighboring.
		for j=1:length(Cand)
			NW=NARVAL_G_NodeNeighbors(Cand(j),g);
			CandWN=[CandWN length(find(gnc(NW)==Col(1)))];
		end
		//the candidate with the maximum such value is chosen to be dyed black
		[maxCandWN ,kind]=max(CandWN);//select the first occurence of the maximum value inside CandWN
		SC=Cand(kind);//selected candidate
		T=unique([T SC]);//add the candidate in T
		//color all neighbors of SC
		N=NARVAL_G_NodeNeighbors(SC,g);
		Nc=N(find(gnc(N)<>Col(3)));//all neighbors non-black (white or grey)
		gnc(Nc)=Col(2);
		gnb(Nc)=3;
		T=unique([T Nc]);
		gnc(SC)=Col(3);
		gnb(SC)=5;
	end
	g.node_color=gnc;
	g.node_border=gnb;
	nucleus=find(gnc==Col(3));
	electron=find(gnc==Col(2));
	ec=ones(1,l);
	eb=ones(1,l);
	wcdsl=[];
	for i=1:length(nucleus)
		wcdsl=[wcdsl find(g.head==nucleus(i)) find(g.tail==nucleus(i))];
	end
	ec(wcdsl)=Col(3);
	eb(wcdsl)=3;
	g.edge_color=ec;
	g.edge_width=eb;
endfunction

